#!/usr/bin/perl

$n = 0;
while(<>)
{
    @line = split;
    $x[$n] = $line[0]; 
    $y[$n] = $line[1]; 
    $err[$n] = $line[2]; 
    $err2 = $err[$n]**2; 
    $s += 1 / $err2;
    $sumx  += $x[$n] / $err2 ;
    $sumy  += $y[$n] / $err2 ;
    $sumxx += $x[$n]*$x[$n] / $err2 ;
    $sumxy += $x[$n]*$y[$n] / $err2 ;
    $n++;
}

$delta = $s * $sumxx - $sumx * $sumx ;
$c = ($sumy * $sumxx - $sumx * $sumxy) / $delta ;
$m = ($s  *  $sumxy - $sumx * $sumy) / $delta ;
$errm = sqrt($s / $delta) ;
$errc = sqrt($sumxx / $delta) ;

printf ("slope     = %10.4f +/- %7.4f \n", $m, $errm);
printf ("intercept = %10.4f +/- %7.4f \n\n", $c, $errc);

$NDF = $n - 2; # the no. of degrees of freedom is n-no. of fit params
$chisq = 0;
for ($i = 0; $i < $n; $i++)
{
    $chisq += (($y[$i] - $m*$x[$i] - $c)/$err[$i])**2;
}
$chisq /= $NDF; 
printf ("chi squared / NDF = %7.4lf \n", $chisq);
